#!/usr/bin/env ruby
#
# Net Responsibility
#
# Copyright (C) 2007-2011 Scott Severance & Robert Rosman
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# Author:
#	Scott Severance <http://www.scottseverance.us>

require 'list-generator-inc'
include List_generator

def list_file_lines
	output_lines = []
	output_lines.push(mk_file_list(
		:source => 'src/net-responsibility.conf',
		:dest   => '/etc/net-responsibility.conf',
		:type   => 'c',
		:mode   => 0600
	))
	output_lines.push(mk_file_list(
		:source => 'src/net-responsibility-daemon.ctrl',
		:dest   => 'net-responsibility-daemon',
		:mode   => 0755,
		:type   => 'i',
		:options=> set_runlevels
	))
	#[2,3,4,5].each do |runlevel|
	#  output_lines.push(mk_symlink(
	#    :target => '../init.d/net-responsibility-daemon',
	#    :link   => "/etc/rc#{runlevel}.d/S50net-responsibility-daemon"
	#  ))
	#end
	#[0,1,6].each do |runlevel|
	#  output_lines.push(mk_symlink(
	#    :target => '../init.d/net-responsibility-daemon',
	#    :link   => "/etc/rc#{runlevel}.d/K50net-responsibility-daemon"
	#  ))
	#end
	output_lines.push(mk_file_list(
		:source => 'src/net-responsibility.desktop',
		:dest   => '/usr/share/applications/net-responsibility.desktop'
	))
	output_lines.push(mk_symlink(
		:target => '/usr/share/net-responsibility/net-responsibility-daemon',
		:link   => '/usr/local/bin/net-responsibility-daemon'
	))
	output_lines.push(mk_symlink(
		:target => '/usr/share/net-responsibility/net-responsibility-report',
		:link   => '/usr/local/bin/net-responsibility-report'
	))
	#output_lines.push(mk_symlink(
	#  :target => '/usr/share/net-responsibility/net-responsibility-report',
	#  :link   => '/etc/cron.daily/net-responsibility-report'
	#))
	output_lines.push(mk_symlink(
		:target => '/usr/share/net-responsibility/net-responsibility-config-cli',
		:link   => '/usr/local/bin/net-responsibility-config-cli'
	))
	output_lines.push(mk_symlink(
		:target => '/usr/share/net-responsibility/net-responsibility-config-gui',
		:link   => '/usr/local/bin/net-responsibility-config-gui'
	))
	
	get_icon_sizes.each do |size|
		output_lines.push(mk_file_list(
			:source => '-', :type => 'd',
			:dest   => "/usr/share/icons/hicolor/#{size}x#{size}/apps",
			:mode   => 0755
		))
		output_lines.push(mk_file_list(
			:source => "src/images/logo_#{size}.png",
			:dest   => "/usr/share/icons/hicolor/#{size}x#{size}/apps/net-responsibility.png"
		))
	end
	
	$files = [{:source => '-',
			:dest   => '/usr/share/net-responsibility',
			:type   => 'd',
			:mode   => '0755',
			:owner  => 'root',
			:group  => 'root'}]
	
	list_files(Dir.pwd + '/src', 'src/')
	
	$files.delete_if do |f|
		if f[:source] =~ /(\.conf|\.ctrl|\.desktop|~)$/
		true
		else false
		end
	end
	
	$files.each do |f|
		f[:dest].gsub!(/share\/src/,'share/net-responsibility')
	end
	
	$epm_f_lines = []
	
	to_f_lines($files)
	output_lines.each {|l| $epm_f_lines.push l}
	$epm_f_lines
end
