raise "Can't run this file directly" unless defined? $lib_dir
# Net Responsibility
#
# Copyright (C) 2007-2011 Scott Severance & Robert Rosman
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# Author:
#	Scott Severance <http://www.scottseverance.us>

require "date"

# We're modifying the DateTime class in the standard distribution...
class DateTime
	def to_s
		"%d-%02d-%02d %02d:%02d:%02d %s" % [year, month, day, hour, min,
																				sec, zone]
	end
	
	def email_date
		"%s, %02d %s %d %02d:%02d:%02d %s" %
						[ABBR_DAYNAMES[wday], day, ABBR_MONTHNAMES[month], year,
						 hour, min, sec, zone]
	end
	
	def to_date_str
		"%04d-%02d-%02d" % [year, month, day]
	end
	
	def compact
		a = "%04d%02d%02d%02d%02d%02d" % [year, month, day, hour, min, sec]
		a.to_i
	end
	
	def self.uncompact(compact_str)
		a = compact_str.to_s
		a.gsub!(/([\d]{4})([\d]{2})([\d]{2})([\d]{2})([\d]{2})([\d]{2})/,
					 '\1-\2-\3 \4:\5:\6')
		DateTime.new a
	end
	
	def compact_date
		a = "%04d%02d%02d" % [year, month, day]
		a.to_i
	end
	
	def self.uncompact_date(date)
		date = date.to_s
		date.gsub(/([\d]{4})([\d]{2})([\d]{2})/, '\1-\2-\3')
	end
	
	def compact_time
		a = "%02d%02d%02d" % [hour, min, sec]
		a.to_i
	end
	
	def self.uncompact_time(time)
		time = "%06d" % time
		time.gsub(/([\d]{2})([\d]{2})([\d]{2})/, '\1:\2:\3')
	end
	
	alias_method :inspect, :to_s
end
