# Net Responsibility
#
# Copyright (C) 2007-2011 Scott Severance & Robert Rosman
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# Author:
#	Scott Severance <http://www.scottseverance.us>
#This stuff works, but it needs to be divided into  more function's i think.
#mpnordland



import smtplib
from sys import argv, exit
import yaml # Library: PyYAML; Ubuntu package: python-yaml
import os
import mimetypes
from email import encoders
from email.mime.base import MIMEBase
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText
#from email.Utils import COMMASPACE

DEBUG = "False"

def usage():
		print """
		Usage:
		%s message-file config-file attach-file debug

		message-file contains the text of the message to be sent, without headers.
		config-file is the Net Responsibility config file (YAML format)
		attach-file is the html-formatted report attachment, or False
		debug is a boolean switch for debug mode. Possible values: True, False
		""" % argv[0]
		exit(2)

def connect_to_SMTP():
	global s
	counter = 0
	while True:  #while 1: works just as well, and it's shorter :)
			if DEBUG:
					print 'counter =', counter
			try:
					s = smtplib.SMTP(smtpinfo['server'], smtpinfo['port'])
					break
			except (smtplib.SMTPException,smtplib.socket.error), e:
					if DEBUG:
							print type(e)
							print e
					counter += 1
					if counter >= 10:
							print 'Unable to establish a connection to the SMTP server. Please check your network connection.'
							raise
							
def create_msg():
		global toaddrs
		global smtpinfo
		global msg
		toaddrs = config['email_to']
		# if toaddrs is not a list, make it one
		if type(toaddrs) != type([]):
			toaddrs=[toaddrs]
		smtpinfo = config['smtp_server']

		msg = MIMEMultipart()
		msg['Subject'] = '%s\'s Net Responsibility Report' % config['name']
		msg['To'] = ", ".join(toaddrs)
		msg['From'] = "%s <%s>" % (config['name'], config['email_from'])

		f = open(msgfile)
		msgbody = MIMEText(f.read().strip(), 'html')
		f.close()
		msg.attach(msgbody)

		if attachfile.lower() != "false" :
				ctype, enc = mimetypes.guess_type(attachfile)
				maintype, subtype = ctype.split('/', 1)
				fp = open(attachfile, 'rb')
				msgattach = MIMEBase(maintype, subtype)
				msgattach.set_payload(fp.read())
				fp.close()
				encoders.encode_base64(msgattach)
				msgattach.add_header('Content-Disposition', 'attachment', filename=os.path.basename(attachfile))
				msg.attach(msgattach)

def set_DEBUG():
	global DEBUG
	if DEBUG.lower() == "false":
		DEBUG=False
	elif DEBUG.lower()=="true":
		DEBUG=True

def send_msg():
	global s
	global result
	
	s.ehlo()
	if smtpinfo['authentication']:
			if smtpinfo['use_tls']:
					s.starttls()
					s.ehlo()
			s.login(smtpinfo['login_name'], smtpinfo['password'])
	result = s.sendmail(config['email_from'],toaddrs,msg.as_string())
	s.quit()

def do_args():
	global msgfile, configfile, attachfile, DEBUG, config
	
	if len(argv) != 5:
			usage()

	msgfile, configfile, attachfile, DEBUG = argv[1:]
	set_DEBUG()
	f = open(configfile)
	config = yaml.load(f)	
	f.close()

do_args()
	
if DEBUG:
		print config
create_msg()


if DEBUG:
		print smtpinfo
connect_to_SMTP()

if DEBUG:
		s.set_debuglevel(1)
send_msg()

if result: # This means that one or more destination addresses were unsuccessful
		for i in result:
				print i
		exit(4)
